﻿using UnityEngine;
using System.Collections.Generic;
using System.Collections;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using HarmonyLib;
using Steamworks;

public class BenevolentSprites : Mod
{
    public static List<HelperSprite> sprites = new List<HelperSprite>();
    static GameObject firePrefab;
    public static List<AI_NetworkBehaviour_Domestic_Resource> animals = new List<AI_NetworkBehaviour_Domestic_Resource>();
    public static List<PickupItem_Networked> eggs = new List<PickupItem_Networked>();
    public static List<BeeHive> beehives = new List<BeeHive>();
    public static List<CookingTable> tables = new List<CookingTable>();
    public static List<CookingTable_Recipe_UI> recipes = new List<CookingTable_Recipe_UI>();
    public static List<Seagull> seagulls = new List<Seagull>();
    public static List<Block_Foundation_ItemNet> itemnets = new List<Block_Foundation_ItemNet>();
    Harmony harmony;
    public static List<Message_InitiateConnection> waiting = new List<Message_InitiateConnection>();
    public static bool gameLoaded = false;
    public static Item_Base repellentItem;
    public static Dictionary<string, Item_Base> spriteItems = new Dictionary<string, Item_Base>();
    public static Dictionary<string, System.Reflection.ConstructorInfo> spriteTypes = new Dictionary<string, System.Reflection.ConstructorInfo>();
    public const string dataKey = "SpriteData";
    public static bool spriteClosingBox = false;
    static bool devMode = false;
    public static GameObject FirePrefab
    {
        get
        {
            if (firePrefab == null)
                foreach (var p in Resources.FindObjectsOfTypeAll<ParticleSystemRenderer>())
                    if (p.name == "Fire_v2") { firePrefab = p.gameObject; break; }
            return firePrefab;
        }
    }
    public void Start()
    {
        if (SceneManager.GetActiveScene().name != Semih_Network.MenuSceneName)
        {
            modlistEntry.modinfo.unloadBtn.GetComponent<Button>().onClick.Invoke();
            throw new ModLoadException("Mod must be loaded on the main menu");
        }
        bool reload = ItemManager.GetItemByName("Sprite_Repellent");
        if (reload)
        {
            repellentItem = ItemManager.GetItemByName("Sprite_Repellent");
            spriteTypes.Add("Garden_Sprite", GetConstructor<GardenSprite>());
            spriteTypes.Add("Animal_Sprite", GetConstructor<AnimalSprite>());
            spriteTypes.Add("Fire_Sprite", GetConstructor<FireSprite>());
            spriteTypes.Add("Fire_Sprite_2", GetConstructor<FireSprite2>());
            spriteTypes.Add("Cleaner_Sprite", GetConstructor<CleanerSprite>());
            foreach (var name in spriteTypes.Keys) {
                var item = ItemManager.GetItemByName(name);
                spriteItems.Add(name, item);
            }
        }
        else
        {
            System.Action<Texture2D> repelTexture = (texture) =>
            {
                for (int x = 0; x < texture.width; x++)
                    for (int y = 0; y < texture.height; y++)
                    {
                        var old = texture.GetPixel(x, y);
                        texture.SetPixel(x, y, new Color(old.r, old.b, old.g, old.a));
                    }
                texture.Apply();
            };
            var originalItem = ItemManager.GetItemByName("Placeable_Lantern_Metal");
            repellentItem = originalItem.Clone(8764, "Sprite_Repellent");
            repellentItem.name = repellentItem.UniqueName;
            repellentItem.settings_Inventory.LocalizationTerm = "";
            repellentItem.settings_Inventory.DisplayName = "Sprite Repellent";
            repellentItem.settings_Inventory.Description = "Deters sprites within a small radius";
            repellentItem.settings_recipe = new ItemInstance_Recipe(CraftingCategory.Other, false, false, "Sprite Repellent", 0);
            repellentItem.settings_recipe.SetRecipe(new CostMultiple[]
                {
                    new CostMultiple(new Item_Base[] {ItemManager.GetItemByName("Scrap") }, 2 ),
                    new CostMultiple(new Item_Base[] {ItemManager.GetItemByName("Glass")},1)
                }, 2);
            repellentItem.settings_recipe.LearnedViaBlueprint = true;
            var prefabs = Traverse.Create(repellentItem.settings_buildable).Field<Block[]>("blockPrefabs");
            var newPrefabs = new Block[prefabs.Value.Length];
            for (int i = 0; i < prefabs.Value.Length; i++)
            {
                newPrefabs[i] = Instantiate(prefabs.Value[i], new Vector3(float.NaN, float.NaN, float.NaN), new Quaternion(0, 0, 0, 1), null);
                newPrefabs[i].gameObject.AddComponent<SpriteRepellent>();
                DestroyImmediate(newPrefabs[i].GetComponent<LightSingularityExternal>());
                var lightObj = new GameObject("lightEmitter");
                lightObj.transform.SetParent(newPrefabs[i].transform, false);
                lightObj.transform.localPosition = Vector3.up * 0.1f;
                var light = lightObj.AddComponent<Light>();
                light.color = new Color(1, 0, 1, 0.6f);
                light.intensity = 3;
                light.range = 1;
                newPrefabs[i].itemToReturnOnDestroy = repellentItem;
                newPrefabs[i].buildableItem = repellentItem;
                foreach (var rend in newPrefabs[i].GetComponentsInChildren<MeshRenderer>())
                {
                    rend.material = new Material(rend.material);
                    var tex = ((Texture2D)rend.material.GetTexture(298)).GetReadable();
                    rend.material.SetTexture(298, tex);
                    repelTexture(tex);
                }
                newPrefabs[i].name = repellentItem.UniqueName;
                DontDestroyOnLoad(newPrefabs[i]);
            }
            prefabs.Value = newPrefabs;
            Traverse.Create(repellentItem.settings_Inventory).Field("stackSize").SetValue(10);
            repellentItem.settings_Inventory.Sprite = originalItem.settings_Inventory.Sprite.GetReadable();
            repelTexture(repellentItem.settings_Inventory.Sprite.texture);
            foreach (var type in Resources.FindObjectsOfTypeAll<SO_BlockQuadType>())
                if (type.AcceptsBlock(originalItem))
                    Traverse.Create(type).Field("acceptableBlockTypes").GetValue<List<Item_Base>>().Add(repellentItem);

            var baseTex = new Texture2D(128, 128);
            baseTex.LoadImage(GetEmbeddedFileBytes("sprite.png"));
            System.Func<Color, Sprite> spriteTexture = (color) =>
            {
                var sprite = Sprite.Create(new Texture2D(baseTex.width, baseTex.height, baseTex.format, false), new Rect(0, 0, baseTex.width, baseTex.height), new Vector2(0, 0), 1);
                var texture = sprite.texture;
                System.Func<float, float, float, float> edit = (v, s, b) => 1 - (1 - v * s) * (1 - b);
                for (int x = 0; x < texture.width; x++)
                    for (int y = 0; y < texture.height; y++)
                    {
                        var c = baseTex.GetPixel(x, y);
                        var b = Mathf.Max(c.r * 2 - 1, 0);
                        var s = Mathf.Min(c.r * 2, 1);

                        if (c.a == 0)
                            texture.SetPixel(x, y, Color.clear);
                        else
                            texture.SetPixel(x, y, new Color(edit(color.r, s, b), edit(color.g, s, b), edit(color.b, s, b), c.a));
                    }
                texture.Apply();
                return sprite;
            };

            originalItem = ItemManager.GetItemByName("Plank");
            var newItem = originalItem.Clone(8765, "Garden_Sprite");
            newItem.settings_Inventory.LocalizationTerm = "";
            newItem.settings_Inventory.DisplayName = "Garden Sprite";
            newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby plants.";
            Traverse.Create(newItem.settings_Inventory).Field("stackSize").SetValue(1);
            newItem.settings_Inventory.Sprite = spriteTexture(new Color(0.2f, 1, 0));
            Traverse.Create(newItem.settings_recipe).Field("blueprintItem").SetValue(repellentItem);
            spriteItems.Add(newItem.UniqueName, newItem);
            spriteTypes.Add(newItem.UniqueName, GetConstructor<GardenSprite>());

            newItem = spriteItems["Garden_Sprite"].Clone(8766, "Animal_Sprite");
            newItem.settings_Inventory.DisplayName = "Animal Sprite";
            newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby animals.";
            newItem.settings_Inventory.Sprite = spriteTexture(new Color(1, 0, 1));
            spriteItems.Add(newItem.UniqueName, newItem);
            spriteTypes.Add(newItem.UniqueName, GetConstructor<AnimalSprite>());

            newItem = spriteItems["Garden_Sprite"].Clone(8767, "Fire_Sprite");
            newItem.settings_Inventory.DisplayName = "Fire Sprite";
            newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby grills and smelters.";
            newItem.settings_Inventory.Sprite = spriteTexture(new Color(1, 0, 0));
            spriteItems.Add(newItem.UniqueName, newItem);
            spriteTypes.Add(newItem.UniqueName, GetConstructor<FireSprite>());

            newItem = spriteItems["Garden_Sprite"].Clone(8768, "Fire_Sprite_2");
            newItem.settings_Inventory.DisplayName = "Fire Sprite";
            newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby cooking pots.";
            newItem.settings_Inventory.Sprite = spriteTexture(new Color(0.5f, 0, 0));
            spriteItems.Add(newItem.UniqueName, newItem);
            spriteTypes.Add(newItem.UniqueName, GetConstructor<FireSprite2>());

            newItem = spriteItems["Garden_Sprite"].Clone(8769, "Cleaner_Sprite");
            newItem.settings_Inventory.DisplayName = "Cleaner Sprite";
            newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to become irritated by nearby mess.";
            newItem.settings_Inventory.Sprite = spriteTexture(new Color(1, 1, 0));
            spriteItems.Add(newItem.UniqueName, newItem);
            spriteTypes.Add(newItem.UniqueName, GetConstructor<CleanerSprite>());
        }

        if (!devMode)
        {
            modlistEntry.jsonmodinfo.isModPermanent = true;
            HMLLibrary.ModManagerPage.RefreshModState(modlistEntry);
        }

        if (!reload)
        {
            foreach (var item in spriteItems.Values)
                RAPI.RegisterItem(item);
            RAPI.RegisterItem(repellentItem);
            foreach (var rand in Resources.FindObjectsOfTypeAll<SO_RandomDropper>())
                if (rand.name.Contains("Dropper_FishingRod_Metal"))
                {
                    var items = new List<RandomItem>(rand.randomizer.items);
                    items.Add(new RandomItem() { obj = spriteItems["Garden_Sprite"], weight = 1.5f, spawnChance = "" });
                    items.Add(new RandomItem() { obj = spriteItems["Animal_Sprite"], weight = 1.5f, spawnChance = "" });
                    items.Add(new RandomItem() { obj = spriteItems["Fire_Sprite"], weight = 1.5f, spawnChance = "" });
                    items.Add(new RandomItem() { obj = spriteItems["Fire_Sprite_2"], weight = 0.5f, spawnChance = "" });
                    items.Add(new RandomItem() { obj = spriteItems["Cleaner_Sprite"], weight = 1.5f, spawnChance = "" });
                    rand.randomizer.items = items.ToArray();
                    var total = rand.randomizer.TotalWeight;
                    foreach (var item in rand.randomizer.items)
                        item.spawnChance = (item.weight / total * 100) + "%";
                }
        }

        BlockCreator.RemoveBlockCallStack += RemoveBlock;

        harmony = new Harmony("com.aidanamite.BenevolentSprites");
        harmony.PatchAll();
        Log("Mod has been loaded!");
    }

    public void OnModUnload()
    {
        if (repellentItem)
        {
            harmony.UnpatchAll(harmony.Id);
            BlockCreator.RemoveBlockCallStack -= RemoveBlock;
            Log("Mod has been unloaded!");
        }
    }

    static void RemoveBlock(List<Block> blocks, Network_Player player)
    {
        foreach (var block in blocks)
        {
            if (block is Block_Foundation_ItemNet)
                itemnets.Remove((Block_Foundation_ItemNet)block);
            if (block.GetComponent<BeeHive>())
                beehives.Remove(block.GetComponent<BeeHive>());
            if (block.GetComponent<CookingTable_Recipe_UI>())
                recipes.Remove(block.GetComponent<CookingTable_Recipe_UI>());
            if (block.GetComponent<CookingTable>())
                tables.Remove(block.GetComponent<CookingTable>());
        }
    }

    public static HelperSprite CreateSprite(Storage_Small box, Slot item, uint SpriteIndex = 0)
    {
        if (!spriteTypes.ContainsKey(item.itemInstance.UniqueName))
            return null;
        HelperSprite newFire = (HelperSprite)spriteTypes[item.itemInstance.UniqueName].Invoke(new object[] { box, item, SpriteIndex });
        sprites.Add(newFire);
        if (Semih_Network.IsHost)
            new Message_Sprite_Create(newFire).Message.Broadcast();
        return newFire;
    }
    public static HelperSprite CreateSprite(Message_InitiateConnection message)
    {
        if (message.appBuildID == MessageType.Create)
        {
            var data = new Message_Sprite_Create(message);
            return CreateSprite(data.Box, data.Slot, data.SpriteIndex);
        }
        else if (message.appBuildID == MessageType.Recreate)
        {
            var data = new Message_Sprite_Recreate(message);
            var sprite = CreateSprite(data.Box, data.Slot, data.SpriteIndex);
            sprite.gameObject.transform.localPosition = data.Position;
            sprite.SetTarget(sprite.FindTarget(data.TargetIndex).transform, data.Offset);
            return sprite;
        }
        return null;
    }
    public static HelperSprite CreateSprite(string serial)
    {
        //Debug.Log("Restoring sprite from serial");
        var data = serial.Bytes();
        var sprite = CreateSprite(new Message_InitiateConnection(0, MessageType.Recreate, serial));
        sprite.holding.AddRange(data.Items(out int inc, 40));
        List<byte> extra = new List<byte>();
        for (int i = 40 + inc; i < data.Length; i++)
            extra.Add(data[i]);
        sprite.RestoreData(extra.ToArray());
        if (sprite.store.itemInstance.TryGetData(out var d))
            sprite.store.itemInstance.RemoveValue(dataKey);
        else
            sprite.store.itemInstance.exclusiveString = "";
        return sprite;
    }

    public void Update()
    {
        for (int i = sprites.Count - 1; i >= 0; i--)
            if (sprites[i].IsDead)
                sprites.RemoveAt(i);
            else
                sprites[i].Update(Time.deltaTime);
        var message = RAPI.ListenForNetworkMessagesOnChannel(MessageType.ChannelID);
        while (message != null && message.message != null && message.message is Message_InitiateConnection && message.message.Type == MessageType.MessageID)
        {
            var msg = (Message_InitiateConnection)message.message;
            if (gameLoaded)
                ProcessMessage(msg);
            else
                waiting.Add(msg);
            message = RAPI.ListenForNetworkMessagesOnChannel(MessageType.ChannelID);
        }
    }

    public static void ProcessMessage(Message_InitiateConnection msg) => ((Message_Sprite)MessageType.Contructor[msg.appBuildID].Invoke(new object[] { msg })).Use();

    public override void WorldEvent_OnPlayerConnected(CSteamID steamid, RGD_Settings_Character characterSettings)
    {
        if (Semih_Network.IsHost)
            foreach (var sprite in sprites)
                new Message_Sprite_Recreate(sprite).Message.Send(steamid);
    }
    public override void WorldEvent_WorldLoaded()
    {
        if (Semih_Network.IsHost)
        {
            gameLoaded = true;
            foreach (var box in StorageManager.allStorages)
            {
                var placed = new List<Slot>();
                foreach (var slot in box.GetInventoryReference().allSlots)
                    if (slot.HasSprite() && placed.AddUniqueOnly(slot))
                    {
                        try
                        {
                            //Debug.Log("Sprite has " + slot.itemInstance.exclusiveString.Length + " chars of data");
                            if (!slot.itemInstance.TryGetData(out var data) && slot.itemInstance.exclusiveString != "")
                            {
                                data.Add(dataKey, slot.itemInstance.exclusiveString);
                                slot.itemInstance.SetData(data);
                            }
                            if (data.ContainsKey(dataKey))
                                CreateSprite(data[dataKey]);
                            else
                                CreateSprite(box, slot);
                        }
                        catch (System.Exception err)
                        {
                            Debug.LogError("Failed to create sprite in slot " + box.GetInventoryReference().allSlots.IndexOf(slot) + " of " + box.name + " (" + box.ObjectIndex + ")\n" + err.GetType().Name + ": " + err.Message + "\n" + err.StackTrace);
                        }
                    }
            }
        }
    }

    [ConsoleCommand(name: "clearSpriteData", docs: "Clears any cache data left on sprites in the world")]
    public static string MyCommand(string[] args)
    {
        if (SceneManager.GetActiveScene().name != Semih_Network.GameSceneName)
            return "Can only be used in world";
        foreach (var s in RAPI.GetLocalPlayer().Inventory.allSlots)
            if (s.HasSprite())
            {
                if (s.itemInstance.TryGetData(out var data))
                    s.itemInstance.RemoveValue(dataKey);
                else
                    s.itemInstance.exclusiveString = "";
            }
        foreach (var b in StorageManager.allStorages)
            foreach (var s in b.GetInventoryReference().allSlots)
                if (s.HasSprite())
                {
                    if (s.itemInstance.TryGetData(out var data))
                        s.itemInstance.RemoveValue(dataKey);
                    else
                        s.itemInstance.exclusiveString = "";
                }
        return "Sprite data cleared";
    }

    public override void WorldEvent_WorldUnloaded()
    {
        gameLoaded = false;
        itemnets.Clear();
        beehives.Clear();
        recipes.Clear();
        tables.Clear();
    }

    public static System.Reflection.ConstructorInfo GetConstructor<T>() where T : HelperSprite => typeof(T).GetConstructor(new System.Type[] { typeof(Storage_Small), typeof(Slot), typeof(uint) });
}

static class ExtentionMethods
{
    static Dictionary<Slot, Storage_Small> refs = new Dictionary<Slot, Storage_Small>();

    public static Sprite GetReadable(this Sprite source) => Sprite.Create(source.texture.GetReadable(), source.rect, source.pivot, source.pixelsPerUnit);

    public static Texture2D GetReadable(this Texture2D source)
    {
        RenderTexture temp = RenderTexture.GetTemporary(source.width, source.height, 0, RenderTextureFormat.Default, RenderTextureReadWrite.Linear);
        Graphics.Blit(source, temp);
        RenderTexture prev = RenderTexture.active;
        RenderTexture.active = temp;
        Texture2D texture = new Texture2D(source.width, source.height);
        texture.ReadPixels(new Rect(0, 0, temp.width, temp.height), 0, 0);
        texture.Apply();
        RenderTexture.active = prev;
        RenderTexture.ReleaseTemporary(temp);
        return texture;
    }
    public static Sprite CreateEmpty(this Sprite sprite)
    {
        return Sprite.Create(new Texture2D(sprite.texture.width, sprite.texture.height,TextureFormat.RGBA32,false), sprite.rect, sprite.pivot, sprite.pixelsPerUnit);
    }
    public static Item_Base Clone(this Item_Base source, int uniqueIndex, string uniqueName)
    {
        Item_Base item = ScriptableObject.CreateInstance<Item_Base>();
        item.Initialize(uniqueIndex, uniqueName, source.MaxUses);
        item.settings_buildable = source.settings_buildable.Clone();
        item.settings_consumeable = source.settings_consumeable.Clone();
        item.settings_cookable = source.settings_cookable.Clone();
        item.settings_equipment = source.settings_equipment.Clone();
        item.settings_Inventory = source.settings_Inventory.Clone();
        item.settings_recipe = source.settings_recipe.Clone();
        item.settings_usable = source.settings_usable.Clone();
        return item;
    }

    public static void SetRecipe(this ItemInstance_Recipe item, CostMultiple[] cost, int amountToCraft = 1)
    {
        Traverse.Create(item).Field("amountToCraft").SetValue(amountToCraft);
        item.NewCost = cost;
    }

    public static bool HasSprite(this Slot slot)
    {
        return slot.HasValidItemInstance() && BenevolentSprites.spriteItems.ContainsKey(slot.itemInstance.UniqueName);
    }

    public static HelperSprite GetSprite(this Slot slot)
    {
        foreach (var sprite in BenevolentSprites.sprites)
            if (sprite.store == slot)
                return sprite;
        return null;
    }

    public static int Missing(this Fuel fuel) => fuel.MaxFuel - fuel.GetFuelCount();

    public static void ForceStart(this CookingTable table, SO_CookingTable_Recipe recipe)
    {
        if (recipe == null)
            return;
        table.CurrentRecipe = recipe;
        table.CookTimer = 0f;
        table.Portions = 0;
        table.StartCoroutine(Traverse.Create(table).Method("SetAnimationState", new object[] { true, Traverse.Create(table).Field("startAnimDelay").GetValue<float>() }).GetValue<IEnumerator>());
        if (table is CookingTable_Pot)
            ((CookingTable_Pot)table).Fuel.StartBurning();
    }

    public static void Clear(this CookingTable table)
    {
        table.Portions = 0;
        table.CurrentRecipe = null;
        Traverse.Create(table).Field("gooModel").GetValue<GameObject>().SetActive(false);
        Traverse.Create(table).Field("finishedModel").GetValue<GameObject>().SetActive(false);
    }

    public static void Clear(this PickupChanneling pickup)
    {
        while (pickup.ItemsRemaining != 0)
            pickup.YieldHandler.RemoveYield();
        pickup.pickupItem.networkID.OnPickedUp?.Invoke();
    }

    public static Storage_Small GetStorage(this Slot slot)
    {
        if (refs.ContainsKey(slot))
        {
            if (refs[slot] == null)
            {
                var inv = Traverse.Create(slot).Field("inventory").GetValue<Inventory>();
                foreach (var storage in StorageManager.allStorages)
                    if (storage.GetInventoryReference() == inv)
                    {
                        refs[slot] = storage;
                        return storage;
                    }
                }
            return refs[slot];
        } else
        {
            var inv = Traverse.Create(slot).Field("inventory").GetValue<Inventory>();
            foreach (var storage in StorageManager.allStorages)
                if (storage.GetInventoryReference() == inv)
                {
                    refs.Add(slot,storage);
                    return storage;
                }
        }
        return null;
    }

    public static void Close(this Storage_Small box)
    {
        BenevolentSprites.spriteClosingBox = true;
        new Message_Storage_Close(Messages.StorageManager_Close, RAPI.GetLocalPlayer().StorageManager, box).Broadcast(NetworkChannel.Channel_Game);
        BenevolentSprites.spriteClosingBox = false;
    }

    public static bool Contains(this List<ItemInstance> items, Item_Base item)
    {
        foreach (var i in items)
            if (i.Valid && i.baseItem == item)
                return true;
        return false;
    }

    public static int GetCount(this List<ItemInstance> items, Item_Base item)
    {
        var c = 0;
        foreach (var i in items)
            if (i.baseItem == item)
                c += i.Amount;
        return c;
    }

    public static int GetCount(this List<ItemInstance> items, CostMultiple item)
    {
        var c = 0;
        foreach (var i in items)
            if (item.ContainsItem(i.baseItem))
                c += i.Amount;
        return c;
    }

    public static void Remove(this List<ItemInstance> items, Item_Base item, int Count)
    {
        for (int i = items.Count - 1; i >= 0; i--)
            if (items[i].baseItem == item)
            {
                if (items[i].Amount > Count)
                {
                    items[i].Amount -= Count;
                    return;
                } else
                {
                    Count -= items[i].Amount;
                    items.RemoveAt(i);
                }
            }
    }

    public static CookingTable_Recipe_UI FindRecipe(this CookingTable table, List<ItemInstance> items)
    {
        CookingTable_Recipe_UI nearest = null;
        var min = float.MaxValue;
        foreach (var recipe in BenevolentSprites.recipes)
            if (recipe && recipe.Recipe)
            {
                var dist = (recipe.transform.position - table.transform.position).magnitude;
                if (dist < min && recipe.Recipe.RecipeCost.CanCraftFrom(items))
                {
                    min = dist;
                    nearest = recipe;
                }
            }
        if (min > 2)
            return null;
        return nearest;
    }

    public static bool CanCraftFrom(this CostMultiple[] costs, List<ItemInstance> items)
    {
        foreach (CostMultiple cost in costs)
            if (items.GetCount(cost) < cost.amount)
                return false;
        return true;
    }

    public static List<ItemInstance> TakeItems(this Inventory inventory, CostMultiple[] costs)
    {
        var items = new List<ItemInstance>();
        foreach (CostMultiple cost in costs)
        {
            var c = cost.amount;
            foreach (var slot in inventory.allSlots)
                if (slot.HasValidItemInstance() && cost.ContainsItem(slot.itemInstance.baseItem))
                {
                    if (slot.itemInstance.Amount <= c)
                    {
                        c -= slot.itemInstance.Amount;
                        items.Add(slot.itemInstance.Clone());
                        slot.SetItem(null);
                    } else
                    {
                        items.Add(new Cost(slot.itemInstance.baseItem, c));
                        slot.itemInstance.Amount -= c;
                        c = 0;
                    }
                    if (c == 0)
                        break;
                }
        }
        return items;
    }

    public static void Remove(this List<ItemInstance> items, CostMultiple[] costs)
    {
        foreach (CostMultiple cost in costs)
        {
            var c = cost.amount;
            for (int i = items.Count - 1; i >= 0; i--)
                if (items[i].Valid && cost.ContainsItem(items[i].baseItem))
                {
                    if (items[i].Amount <= c)
                    {
                        c -= items[i].Amount;
                        items.RemoveAt(i);
                    }
                    else
                    {
                        items[i].Amount -= c;
                        c = 0;
                    }
                    if (c == 0)
                        break;
                }
        }
    }

    public static List<ItemInstance> GetAllItems(this Inventory inventory)
    {
        var items = new List<ItemInstance>();
        foreach (var slot in inventory.allSlots)
            if (slot.HasValidItemInstance())
                items.Add(slot.itemInstance);
        return items;
    }

    public static List<ItemInstance> GetAllItems(this PickupItem pickup)
    {
        var items = new List<ItemInstance>();
        if (pickup.yieldHandler)
            items.AddAll(pickup.yieldHandler.Yield);
        if (pickup.dropper)
            items.AddAll(pickup.dropper.GetRandomItems());
        if (pickup.itemInstance != null && pickup.itemInstance.Valid)
            items.Add(pickup.itemInstance);
        if (pickup.specificPickups != null)
        {
            var tempObj = new GameObject();
            Patch_InventoryOverrides.ignore = tempObj;
            tempObj.SetActive(false);
            var tempInv = tempObj.AddComponent<PlayerInventory>();
            tempInv.hotslotCount = 1;
            tempInv.hotbar = tempObj.AddComponent<Hotbar>();
            Traverse.Create(tempInv).Field("inventoryPickup").SetValue(tempObj.AddComponent<InventoryPickup>());
            var tempTxt = new GameObject().AddComponent<Text>();
            for (int i = 0; i < 20; i++)
            {
                var s = new GameObject().AddComponent<Slot>();
                s.rectTransform = s.gameObject.AddComponent<RectTransform>();
                s.active = true;
                s.textComponent = tempTxt;
                tempInv.allSlots.Add(s);
            }
            foreach (var specificPickup in pickup.specificPickups)
            {
                specificPickup.PickupSpecific(tempInv);
                items.AddRange(tempInv.GetAllItems());
                foreach (var slot in tempInv.allSlots)
                    slot.SetItem(null);
            }
            foreach (var slot in tempInv.allSlots)
                GameObject.Destroy(slot);
            GameObject.Destroy(tempTxt.gameObject);
            GameObject.Destroy(tempObj);
        }
        return items;
    }

    public static void AddAll(this List<ItemInstance> items, IEnumerable<Cost> newItems)
    {
        if (newItems != null)
            foreach (var cost in newItems)
                if (cost != null)
                    items.Add(new ItemInstance(cost.item, cost.amount, cost.item.MaxUses));
    }
    public static void AddAll(this List<ItemInstance> items, IEnumerable<Item_Base> newItems)
    {
        if (newItems != null)
            foreach (var item in newItems)
                if (item != null)
                    items.Add(new ItemInstance(item, 1, item.MaxUses));
    }
    public static void AddAll(this List<ItemInstance> items, IEnumerable<ItemInstance> newItems)
    {
        if (newItems != null)
            foreach (var item in newItems)
                if (item != null)
                    items.Add(item);
    }
    public static void Add(this List<ItemInstance> items, Cost cost)
    {
        if (cost != null)
            items.Add(new ItemInstance(cost.item, cost.amount, cost.item.MaxUses));
    }
    public static void Add(this List<ItemInstance> items, Item_Base item)
    {
        if (item)
            items.Add(new ItemInstance(item, 1, item.MaxUses));
    }
    public static void Remove(this PickupItem_Networked pickup)
    {
        if (pickup.stopTrackUseRPC)
        {
            PickupObjectManager.RemovePickupItemNetwork(pickup, new CSteamID(0));
        }
        else
        {
            PickupObjectManager.RemovePickupItem(pickup, new CSteamID(0));
        }
    }
    public static Item_Base FindItem(this Inventory inventory, CookingStand stand, CookingSlot slot, out List<CookingSlot> slots)
    {
        slots = null;
        foreach (var s in inventory.allSlots)
            if (s.HasValidItemInstance() && slot.CanCookItem(s.itemInstance.baseItem))
            {
                slots = stand.FindSlots(s.itemInstance.baseItem, slot);
                if (slots != null)
                    return s.itemInstance.baseItem;
            }
        return null;
    }

    public static List<CookingSlot> FindSlots(this CookingStand stand, Item_Base item, CookingSlot containsSlot)
    {
        if (item == null)
            return null;
        List<CookingSlot> list = new List<CookingSlot>();
        for (int i = 0; i < stand.cookingSlots.Length; i++)
        {
            CookingSlot cookingSlot = stand.cookingSlots[i];
            if (!cookingSlot.IsBusy && cookingSlot.CanCookItem(item))
            {
                list.Add(cookingSlot);
                if (list.Count >= item.settings_cookable.CookingSlotsRequired)
                {
                    if (list.Contains(containsSlot))
                        return list;
                    else
                        list.RemoveAt(0);
                }
            }
        }
        return null;
    }

    public static bool IsRepelled(this Transform t)
    {
        foreach (var g in SpriteRepellent.repellents)
            if (UnityEngine.Vector3.Distance(t.position, g.transform.position) < 1.5)
                return true;
        return false;
    }
    public static bool IsRepelled(this Transform t, Vector3 off)
    {
        foreach (var g in SpriteRepellent.repellents)
            if (UnityEngine.Vector3.Distance(t.TransformPoint(off), g.transform.position) < 1.5)
                return true;
        return false;
    }

    public static string String(this byte[] bytes, int length = -1, int offset = 0)
    {
        if (bytes.Length % 2 == 1) {
            var n = new byte[bytes.Length + 1];
            bytes.CopyTo(n, 0);
            bytes = n;
        }
        string str = "";
        if (length == -1)
            length = (bytes.Length - offset) / 2;
        while (str.Length < length)
        {
            str += System.BitConverter.ToChar(bytes,offset + str.Length * 2);
        }
        return str;
        
    }
    public static string String(this List<byte> bytes) => bytes.ToArray().String();
    public static byte[] Bytes(this string str) {
        var data = new List<byte>();
        foreach (char chr in str)
            data.AddRange(System.BitConverter.GetBytes(chr));
        return data.ToArray();
    }
    public static int Integer(this byte[] bytes, int offset = 0) => System.BitConverter.ToInt32(bytes, offset);
    public static uint UInteger(this byte[] bytes, int offset = 0) => System.BitConverter.ToUInt32(bytes, offset);
    public static float Float(this byte[] bytes, int offset = 0) => System.BitConverter.ToSingle(bytes, offset);
    public static Vector3 Vector3(this byte[] bytes, int offset = 0) => new Vector3(bytes.Float(offset), bytes.Float(offset + 4), bytes.Float(offset + 8));
    public static ItemInstance Item(this byte[] bytes, out int size, int offset = 0)
    {
        var stringSize = bytes.Integer(offset + 12);
        size = stringSize / 2 + 16;
        return new ItemInstance(ItemManager.GetItemByIndex(bytes.Integer(offset)), bytes.Integer(offset + 4), bytes.Integer(offset + 8), bytes.String(stringSize, offset + 16));
    }
    public static List<ItemInstance> Items(this byte[] bytes, out int size, int offset = 0)
    {
        var items = new List<ItemInstance>();
        var count = bytes.Integer(offset);
        size = 4;
        while (items.Count < count)
        {
            items.Add(bytes.Item(out int inc, offset + size));
            size += inc;
        }
        return items;
    }
    public static CookingSlotTargets CookingSlotTargets(this byte[] bytes, int offset = 0) => new CookingSlotTargets(bytes.UInteger(offset), bytes.Integer(offset + 4), bytes.Integer(offset + 8));
    public static byte[] Bytes(this int value) => System.BitConverter.GetBytes(value);
    public static byte[] Bytes(this uint value) => System.BitConverter.GetBytes(value);
    public static byte[] Bytes(this float value) => System.BitConverter.GetBytes(value);
    public static byte[] Bytes(this Vector3 value)
    {
        var data = new byte[12];
        value.x.Bytes().CopyTo(data, 0);
        value.y.Bytes().CopyTo(data, 4);
        value.z.Bytes().CopyTo(data, 8);
        return data;
    }
    public static byte[] Bytes(this ItemInstance value)
    {
        var data = new List<byte>();
        data.AddRange(value.baseItem.UniqueIndex.Bytes());
        data.AddRange(value.Amount.Bytes());
        data.AddRange(value.Uses.Bytes());
        data.AddRange(value.exclusiveString.Length.Bytes());
        data.AddRange(value.exclusiveString.Bytes());
        return data.ToArray();
    }
    public static byte[] Bytes(this IEnumerable<ItemInstance> values)
    {
        var data = new List<byte>();
        int count = 0;
        foreach (var item in values)
        {
            data.AddRange(item.Bytes());
            count++;
        }
        data.InsertRange(0, count.Bytes());
        return data.ToArray();
    }
    public static byte[] Bytes(this CookingSlotTargets value)
    {
        var data = new byte[12];
        value.ObjectIndex.Bytes().CopyTo(data, 0);
        value.slotInd.Bytes().CopyTo(data, 4);
        value.slotCount.Bytes().CopyTo(data, 8);
        return data;
    }

    public static void Broadcast(this Message message, NetworkChannel channel = (NetworkChannel)MessageType.ChannelID) => ComponentManager<Semih_Network>.Value.RPC(message, Target.Other, EP2PSend.k_EP2PSendReliable, channel);
    public static void Send(this Message message, CSteamID steamID) => ComponentManager<Semih_Network>.Value.SendP2P(steamID, message, EP2PSend.k_EP2PSendReliable, (NetworkChannel)MessageType.ChannelID);

    public static void SetValue(this ItemInstance item, string valueName, string value)
    {
        int pos = 0;
        var data = item.exclusiveString.Bytes();
        var newData = new List<byte>(data);
        while (pos < data.Length)
        {
            var l = data.Integer(pos);
            var name = data.String(l, pos + 4);
            pos += 4 + name.Length * 2;
            l = data.Integer(pos);
            var oldValue = data.String(l, pos + 4);
            if (name == valueName)
            {
                newData.RemoveRange(pos, 4 + oldValue.Length * 2);
                newData.InsertRange(pos, value.Bytes());
                newData.InsertRange(pos, value.Length.Bytes());
                break;
            }
            pos += 4 + oldValue.Length * 2;
        }
        if (pos >= data.Length)
        {
            newData.AddRange(valueName.Length.Bytes());
            newData.AddRange(valueName.Bytes());
            newData.AddRange(value.Length.Bytes());
            newData.AddRange(value.Bytes());
        }
        //Debug.Log("Data changed from " + (item.exclusiveString.Length * 2) + " to " + newData.Count);
        item.exclusiveString = newData.String();
    }

    public static string GetValue(this ItemInstance item, string valueName)
    {
        int pos = 0;
        var data = item.exclusiveString.Bytes();
        while (pos < data.Length)
        {
            var l = data.Integer(pos);
            var name = data.String(l, pos + 4);
            pos += 4 + name.Length * 2;
            l = data.Integer(pos);
            var value = data.String(l, pos + 4);
            pos += 4 + value.Length * 2;
            if (name == valueName)
                return value;
        }
        throw new System.MissingFieldException("No value \"" + valueName + "\" was found on the ItemInstance");
    }

    public static bool RemoveValue(this ItemInstance item, string valueName)
    {
        int pos = 0;
        var data = item.exclusiveString.Bytes();
        while (pos < data.Length)
        {
            var l = data.Integer(pos);
            var name = data.String(l, pos + 4);
            var offset = 4 + name.Length * 2;
            l = data.Integer(pos + offset);
            var value = data.String(l, pos + offset + 4);
            offset += 4 + value.Length * 2;
            if (name == valueName)
            {
                var newData = new List<byte>(data);
                newData.RemoveRange(pos, offset);
                item.exclusiveString = newData.String();
                return true;
            }
            pos += offset;
        }
        return false;
    }

    public static Dictionary<string,string> GetData(this ItemInstance item)
    {
        int pos = 0;
        var data = item.exclusiveString.Bytes();
        var d = new Dictionary<string, string>();
        while (pos < data.Length)
        {
            var l = data.Integer(pos);
            var name = data.String(l, pos + 4);
            pos += 4 + name.Length * 2;
            l = data.Integer(pos);
            var value = data.String(l, pos + 4);
            pos += 4 + value.Length * 2;
            d.Add(name, value);
        }
        return d;
    }

    public static bool TryGetData(this ItemInstance item, out Dictionary<string, string> values)
    {
        try
        {
            values = item.GetData();
            return true;
        } catch
        {
            values = new Dictionary<string, string>();
            return false;
        }
    }

    public static void SetData(this ItemInstance item, Dictionary<string, string> values)
    {
        var data = new List<byte>();
        foreach (var pair in values)
        {
            data.AddRange(pair.Key.Length.Bytes());
            data.AddRange(pair.Key.Bytes());
            data.AddRange(pair.Value.Length.Bytes());
            data.AddRange(pair.Value.Bytes());
        }
        item.exclusiveString = data.String();
    }
}

public class SpriteRepellent : MonoBehaviour
{
    public static List<SpriteRepellent> repellents = new List<SpriteRepellent>();
    public void OnBlockPlaced() => repellents.Add(this);
    public void OnDestroy()
    {
        if (repellents.Contains(this))
            repellents.Remove(this);
    }
}

public class HelperSprite
{
    internal GameObject gameObject;
    internal Slot store;
    public List<ItemInstance> holding;
    const float acceleration = 2f;
    const float maxVelocity = 10f;
    Vector3 velocity;
    internal Transform targetObject;
    public Vector3 targetPosition;
    Vector3 randomAccel;
    Vector3 targetRand;
    float time;
    internal bool dying;
    public uint ObjectIndex { private set; get; }
    internal Storage_Small box
    {
        get
        {
            return store.GetStorage();
        }
    }
    public bool IsDead
    {
        get { return gameObject == null; }
    }
    public Vector3 Target
    {
        get
        {
            if (targetObject == null)
                return targetPosition;
            return gameObject.transform.parent.InverseTransformPoint(targetObject.TransformPoint(targetPosition));
        }
    }
    public Vector3 TargetGlobal
    {
        get
        {
            return gameObject.transform.parent.TransformPoint(Target);
        }
    }
    internal float DistanceFromTarget { get { return (Target - gameObject.transform.localPosition).magnitude; } }
    public HelperSprite(Storage_Small container, Slot slot, Color color, uint objectIndex = 0)
    {
        gameObject = GameObject.Instantiate(BenevolentSprites.FirePrefab, GameManager.Singleton.lockedPivot, false);
        if (objectIndex == 0)
            objectIndex = SaveAndLoad.GetUniqueObjectIndex();
        ObjectIndex = objectIndex;
        store = slot;
        gameObject.name = "sprite";
        gameObject.transform.position = container.transform.position;
        gameObject.transform.localScale = Vector3.one / 2;
        foreach (var p in gameObject.GetComponentsInChildren<ParticleSystem>())
        {
            var m = p.main;
            m.startColor = new ParticleSystem.MinMaxGradient(color);
        }
        Light glow = gameObject.AddComponent<Light>();
        glow.color = color;
        glow.intensity = 1;
        glow.range = 2;
        glow.enabled = true;
        gameObject.SetActive(true);
        SetTarget(container.transform, Vector3.up);
        randomAccel = Vector3.zero;
        dying = false;
        holding = new List<ItemInstance>();
    }
    public void SetTarget(Transform target, Vector3 position)
    {
        targetObject = target;
        targetPosition = position;
    }
    public void SetTargetNetwork(MonoBehaviour_ID target, Vector3 position)
    {
        if (target == null)
            return;
        SetTarget(target.transform, position);
        if (Semih_Network.IsHost)
            new Message_Sprite_SetTarget(this, target, position).Message.Broadcast();
    }

    public void Update(float t)
    {
        if (store == null || !store.HasSprite())
            Kill();
        time += t;
        if (time > 0.2)
        {
            targetRand = new Vector3(Random.Range(-1f, 1f), Random.Range(-1f, 1f), Random.Range(-1f, 1f));
            time -= 0.2f;
        }
        randomAccel = Vector3.Lerp(randomAccel, targetRand, t / 2);
        Vector3 dir = Target + randomAccel - gameObject.transform.localPosition;
        if (!dying)
            velocity += dir.normalized * acceleration * t;
        velocity *= Mathf.Pow(0.3f,t);
        velocity.Clamp(0, maxVelocity);
        gameObject.transform.localPosition += velocity * t;
        AI();
    }

    public virtual void Kill()
    {
        if (!dying)
        {
            if (Semih_Network.IsHost)
                new Message_Sprite_Kill(this).Message.Broadcast();
            CoroutineManager.Singleton.StartCoroutine(Death());
        }
    }

    IEnumerator Death()
    {
        dying = true;
        float timePassed = 0;
        Light light = gameObject.GetComponent<Light>();
        foreach (var item in holding)
            Helper.DropItem(item, gameObject.transform.position, Vector3.down, true);
        while (timePassed < 0.75)
        {
            timePassed += Time.deltaTime / 2;
            float strength = Mathf.Max(Mathf.Sin(timePassed * Mathf.PI) * 3, 0);
            light.intensity = strength;
            light.range = strength * 2;
            yield return new WaitForEndOfFrame();
        }
        Destroy();
        yield break;
    }

    public void Destroy()
    {
        GameObject.Destroy(gameObject);
    }

    void AI()
    {
        if (!Semih_Network.IsHost || dying)
            return;
        if (tryInteract())
        {
            MonoBehaviour_ID target = null;
            Vector3 targetOffset = Vector3.zero;
            if (holding.Count == 0 && targetObject == box.transform)
                pickTarget(out target, out targetOffset);
            if (target == null)
            {
                target = box;
                if (holding.Count == 0)
                    targetOffset = Vector3.up;
                else
                    targetOffset = Vector3.up * 0.2f;
            }
            if ((target == null ? null : target.transform) != targetObject || targetOffset != targetPosition)
                SetTargetNetwork(target, targetOffset);
        }
    }

    internal bool tryDepositHeld()
    {
        if (targetObject == box.transform && DistanceFromTarget < 0.2f && !box.IsOpen)
        {
            bool added = false;
            for (int i = holding.Count - 1; i >= 0; i--)
            {
                int pre = holding[i].Amount;
                box.GetInventoryReference().AddItem(holding[i], false);
                if (pre != holding[i].Amount)
                    added = true;
                if (holding[i].Amount == 0)
                    holding.RemoveAt(i);
            }
            if (added)
            {
                var eventRef = Traverse.Create(ComponentManager<SoundManager>.Value).Field("eventRef_UI_MoveItem").GetValue<string>();
                box.Close();
                var msg = new Message_SoundManager_PlayOneShot(Messages.SoundManager_PlayOneShot, ComponentManager<Semih_Network>.Value.NetworkIDManager, ComponentManager<SoundManager>.Value.ObjectIndex, eventRef, box.transform.position);
                msg.Broadcast();
                FMODUnity.RuntimeManager.PlayOneShot(eventRef, msg.Position);
            }
        }
        return holding.Count == 0;
    }

    internal virtual bool tryInteract()
    {
        return true;
    }

    public virtual void RestoreData(byte[] data) { }
    public virtual byte[] GenerateData() { return new byte[0]; }

    internal virtual void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset) { target = box; targetOffset = Vector3.up; }

    public virtual MonoBehaviour_ID FindTarget(uint objectIndex)
    {
        foreach (var mono in GameObject.FindObjectsOfType<MonoBehaviour_ID>())
            if (mono.ObjectIndex == objectIndex)
                return mono;
        return null;
    }

}

class GardenSprite : HelperSprite
{
    static Dictionary<GardenSprite, PlantationSlot> targeted = new Dictionary<GardenSprite, PlantationSlot>();
    public GardenSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0, 0.125f), Random.Range(0.875f, 1), 0), objectIndex)
    {
        targeted.Add(this, null);
    }

    public override void Kill()
    {
        targeted.Remove(this);
        base.Kill();
    }

    internal override bool tryInteract()
    {
        if (targetObject == null)
            return true;
        if (targetObject == box.transform)
            return tryDepositHeld();
        if (targetObject.IsRepelled() || box.transform.IsRepelled() || targeted[this].plant == null || !targeted[this].plant.FullyGrown())
        {
            targeted[this] = null;
            return true;
        }
        if (DistanceFromTarget > 0.2f)
            return false;
        holding.AddRange(targeted[this].plant.pickupComponent.GetAllItems());
        var seed = targeted[this].plant.item.UniqueIndex;
        targetObject.GetComponent<Cropplot>().plantManager.Harvest(targeted[this].plant, false);
        new Message_HarvestPlant(Messages.PlantManager_HarvestPlant, targetObject.GetComponent<Cropplot>().plantManager, targeted[this].plant, false).Broadcast(NetworkChannel.Channel_Game);
        foreach (var item in holding)
            if (item.baseItem.UniqueIndex == seed)
            {
                PlantSeed(targetObject.GetComponent<Cropplot>(), seed);
                if (item.Amount == 1)
                    holding.Remove(item);
                else
                    item.Amount--;
                break;
            }
        targeted[this] = null;
        return true;
    }
    internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
    {
        float dist = float.MaxValue;
        target = null;
        targetOffset = Vector3.zero;
        if (box.transform.IsRepelled())
            return;
        targeted[this] = null;
        foreach (var cropplot in PlantManager.allCropplots)
        {
            if (cropplot is Cropplot_Grass)
                continue;
            foreach (var plantation in cropplot.plantationSlots)
            {
                if (targeted.ContainsValue(plantation) || plantation.transform.IsRepelled())
                    continue;
                var newDist = Vector3.Distance(box.transform.position, plantation.transform.position);
                if (plantation.plant && plantation.plant.FullyGrown() && newDist < dist)
                {
                    target = cropplot;
                    targetOffset = plantation.plant.transform.localPosition + Vector3.up * 0.2f;
                    dist = newDist;
                    targeted[this] = plantation;
                }
            }
        }
        if (target)
        {
            if (dist > box.GetInventoryReference().GetSlotCount() / 2)
            {
                target = null;
                targetOffset = Vector3.zero;
                targeted[this] = null;
            }
            else if (!box.IsOpen && box.GetInventoryReference().GetItemCount(targeted[this].plant.item) > 0)
            {
                box.GetInventoryReference().RemoveItem(targeted[this].plant.item.UniqueName, 1);
                box.Close();
                holding.Add(new ItemInstance(targeted[this].plant.item, 1, targeted[this].plant.item.MaxUses));
            }
        }
        else
            targeted[this] = null;
    }

    static void PlantSeed(Cropplot crop, int ItemIndex)
    {
        var msg = new Message_Sprite_PlantSeed(crop, ItemIndex, SaveAndLoad.GetUniqueObjectIndex(), ComponentManager<WeatherManager>.Value.GetCurrentWeatherType() == UniqueWeatherType.Rain);
        msg.Use();
        msg.Message.Broadcast();
    }

    public override void RestoreData(byte[] data)
    {
        if (targetObject.GetComponent<Cropplot>())
            targeted[this] = targetObject.GetComponent<Cropplot>().plantationSlots[data.Integer(0)];
    }
    public override byte[] GenerateData()
    {
        if (targeted[this] != null && targetObject.GetComponent<Cropplot>())
            return targetObject.GetComponent<Cropplot>().plantationSlots.IndexOf(targeted[this]).Bytes();
        return new byte[0];
    }

    public override MonoBehaviour_ID FindTarget(uint objectIndex)
    {
        foreach (var cropplot in PlantManager.allCropplots)
            if (cropplot.ObjectIndex == objectIndex)
                return cropplot;
        return base.FindTarget(objectIndex);
    }
}

class AnimalSprite : HelperSprite
{
    static Dictionary<AnimalSprite, MonoBehaviour_ID> targeted = new Dictionary<AnimalSprite, MonoBehaviour_ID>();
    public AnimalSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.125f, 0.25f), 0, Random.Range(0.875f, 1)), objectIndex)
    {
        targeted.Add(this, null);
    }
    public override void Kill()
    {
        targeted.Remove(this);
        base.Kill();
    }

    internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
    {
        target = null;
        targetOffset = Vector3.zero;
        if (box.transform.IsRepelled())
            return;
        float dist = float.MaxValue;
        targeted[this] = null;
        Item_Base requiredItem = null;
        var itemCount = new Dictionary<Item_Base, int>();
        foreach (var animal in BenevolentSprites.animals)
        {
            if (animal == null || targeted.ContainsValue(animal) || animal.transform.IsRepelled())
                continue;
            var newDist = Vector3.Distance(box.transform.position, animal.transform.position);
            var collectionItem = animal.Resource.resource.collectionItem;
            itemCount.TryAdd(collectionItem, box.GetInventoryReference().GetItemCount(collectionItem));
            if (animal.Resource && animal.Resource.IsReady && newDist < dist && (collectionItem.MaxUses != 1 || (!box.IsOpen && itemCount[collectionItem] > 0)))
            {
                if (collectionItem.MaxUses == 1)
                    requiredItem = collectionItem;
                else
                    requiredItem = null;
                target = animal;
                targetOffset = Vector3.up * 0.2f;
                dist = newDist;
                targeted[this] = animal;
            }
        }
        foreach (var item in BenevolentSprites.eggs)
        {
            if (item == null || targeted.ContainsValue(item) || item.transform.IsRepelled())
                continue;
            var newDist = Vector3.Distance(box.transform.position, item.transform.position);
            if (newDist < dist)
            {
                requiredItem = null;
                target = item;
                targetOffset = Vector3.up * 0.2f;
                dist = newDist;
                targeted[this] = item;
            }
        }
        foreach (var hive in BenevolentSprites.beehives)
        {
            if (hive == null || targeted.ContainsValue(hive) || hive.transform.IsRepelled())
                continue;
            var newDist = Vector3.Distance(box.transform.position, hive.transform.position);
            if (hive.currentHoneyLevelIndex != -1 && newDist < dist)
            {
                requiredItem = null;
                target = hive;
                targetOffset = Vector3.up * 0.2f;
                dist = newDist;
                targeted[this] = hive;
            }
        }
        if (BirdsNest.AllNests != null)
            foreach (var nest in BirdsNest.AllNests)
            {
                if (targeted.ContainsValue(nest) || nest.transform.IsRepelled())
                    continue;
                var newDist = Vector3.Distance(box.transform.position, nest.transform.position);
                if ((nest.HasFeather || nest.HasEgg) && newDist < dist)
                {
                    requiredItem = null;
                    target = nest;
                    targetOffset = Vector3.up * 0.2f;
                    dist = newDist;
                    targeted[this] = nest;
                }
            }
        if (target)
        {
            if (dist > box.GetInventoryReference().GetSlotCount() / 2)
            {
                target = null;
                targetOffset = Vector3.zero;
                targeted[this] = null;
            }
            else if (requiredItem)
            {
                box.GetInventoryReference().RemoveItemUses(requiredItem.UniqueName, 1);
                box.Close();
                holding.Add(new ItemInstance(requiredItem, 1, 1));
            }
        }
    }
    internal override bool tryInteract()
    {
        if (targetObject == null)
            return true;
        if (targetObject == box.transform)
            return tryDepositHeld();
        if (targetObject.IsRepelled() || box.transform.IsRepelled())
            return true;
        ResourceRegenerative resource = null;
        var animal = targetObject.GetComponent<AI_NetworkBehaviour_Domestic_Resource>();
        var pickup = targetObject.GetComponent<PickupItem_Networked>();
        var beehive = targetObject.GetComponent<BeeHive>();
        var nest = targetObject.GetComponent<BirdsNest>();
        if (animal)
        {
            resource = animal.Resource;
            if (!resource.IsReady)
            {
                targeted[this] = null;
                return true;
            }
        }
        if ((beehive && beehive.currentHoneyLevelIndex == -1) || (nest && !nest.HasEgg && !nest.HasFeather))
        {
            targeted[this] = null;
            return true;
        }
        if (DistanceFromTarget > 0.2f)
            return false;
        if (animal)
        {
            Item_Base RequiredItem = resource.resource.collectionItem;
            Item_Base _pickup = resource.HarvestResource();
            holding.Add(new ItemInstance(_pickup,1,_pickup.MaxUses));
            if (RequiredItem.MaxUses == 1)
                foreach (var item in holding)
                    if (item.baseItem.UniqueIndex == RequiredItem.UniqueIndex)
                    {
                        if (item.Amount == 1)
                            holding.Remove(item);
                        else
                            item.Amount--;
                        break;
                    }
        }
        else if (beehive)
        {
            holding.AddAll(beehive.CurrentHoneyLevel.yield.yieldAssets);
            new Message_NetworkBehaviour_ID_SteamID(Messages.BeeHiveHarvestOutput, ComponentManager<Semih_Network>.Value.NetworkIDManager, beehive.ObjectIndex, new CSteamID(0)).Broadcast();
            Traverse.Create(beehive).Method("HarvestYield", new System.Type[] { typeof(Network_Player) }, new object[] { null }).GetValue();
        }
        else if (nest)
        {
            var item = Traverse.Create(nest).Field("eggItem").GetValue<Item_Base>();
            if (nest.EggCount > 0)
            {
                holding.Add(new ItemInstance(item, nest.EggCount, item.MaxUses));
                new Message_NetworkBehaviour_SteamID(Messages.BirdsNest_PickupEgg, nest, 0).Broadcast();
                nest.PickupEgg(null);
            }
            item = Traverse.Create(nest).Field("featherItem").GetValue<Item_Base>();
            if (nest.FeatherCount > 0)
            {
                holding.Add(new ItemInstance(item, nest.FeatherCount, item.MaxUses));
                new Message_NetworkBehaviour_SteamID(Messages.BirdsNest_PickupFeather, nest, 0).Broadcast();
                nest.PickupFeather(null);
            }
        }
        else
        {
            holding.AddRange(pickup.PickupItem.GetAllItems());
            pickup.Remove();
        }
        targeted[this] = null;
        return true;
    }

    public override void RestoreData(byte[] data)
    {
        targeted[this] = targetObject.GetComponent<MonoBehaviour_ID>();
    }

    public override MonoBehaviour_ID FindTarget(uint objectIndex)
    {
        foreach (var animal in BenevolentSprites.animals)
            if (animal.ObjectIndex == objectIndex)
                return animal;
        foreach (var item in BenevolentSprites.eggs)
            if (item.ObjectIndex == objectIndex)
                return item;
        foreach (var hive in BenevolentSprites.beehives)
            if (hive.ObjectIndex == objectIndex)
                return hive;
        foreach (var nest in BirdsNest.AllNests)
            if (nest.ObjectIndex == objectIndex)
                return nest;
        return base.FindTarget(objectIndex);
    }
}

class FireSprite : HelperSprite
{
    static Dictionary<FireSprite, CookingSlotTargets> targeted = new Dictionary<FireSprite, CookingSlotTargets>();
    public FireSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.875f, 1), Random.Range(0, 0.125f), 0), objectIndex)
    {
        targeted.Add(this, new CookingSlotTargets(null, -1, 0));
    }
    public override void Kill()
    {
        targeted.Remove(this);
        base.Kill();
    }

    internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
    {
        target = null;
        targetOffset = Vector3.zero;
        if (box.transform.IsRepelled())
            return;
        float dist = float.MaxValue;
        targeted[this] = CookingSlotTargets.Null;
        Item_Base cookItem = null;
        Cost fuel = null;
        var fueling = true;
        var maxDist = box.GetInventoryReference().GetSlotCount() / 2f;
        var newTarget = CookingSlotTargets.Null;
        if (CookingStandManager.allCookingStands != null)
            foreach (var stand in CookingStandManager.allCookingStands)
            {
                if (stand == null || stand is CookingStand_Purifier)
                    continue;
                var f = 0;
                if (!box.IsOpen)
                    f = Mathf.Max(Mathf.Min(stand.fuel.Missing() - InboundFuel(stand), box.GetInventoryReference().GetItemCount(stand.fuel.fuelItem)), 0);
                foreach (var slot in stand.cookingSlots)
                {
                    var flagEmpty = !slot.IsBusy && !box.IsOpen;
                    if ((!slot.IsComplete && !flagEmpty && f == 0) || slot.transform.IsRepelled())
                        continue;
                    Item_Base item = null;
                    List<CookingSlot> fetched = null;
                    if (f != 0 && (targeted.ContainsValue(slot) || (slot.connectedSlot && targeted.ContainsValue(slot.connectedSlot))))
                        continue;
                    else if (flagEmpty)
                    {
                        item = box.GetInventoryReference().FindItem(stand, slot, out fetched);
                        if (!item || fetched == null || targeted.ContainsValue(fetched))
                        {
                            if (f == 0)
                                continue;
                            item = null;
                        }
                    }
                    var newDist = Vector3.Distance(box.transform.position, slot.transform.position);
                    if ((newDist < dist || fueling) && newDist <= maxDist && (slot.IsComplete || item || (f != 0 && fueling)))
                    {
                        fuel = new Cost(stand.fuel.fuelItem, f);
                        cookItem = item;
                        target = stand;
                        if (!slot.IsComplete && !item && !box.IsOpen)
                        {
                            fueling = true;
                            targetOffset = Vector3.up * 0.2f;
                        }
                        else
                        {
                            fueling = false;
                            if (slot.IsComplete)
                                targetOffset = slot.transform.localPosition + Vector3.up * 0.2f;
                            else if (item)
                                targetOffset = fetched[0].transform.localPosition + Vector3.up * 0.2f;
                        }
                        dist = newDist;
                        if (item)
                            newTarget = fetched;
                        else
                        {
                            CookingSlotTargets targets = slot;
                            if (slot.connectedSlot)
                                targets = slot.connectedSlot;
                            if (slot.IsComplete)
                                targets.slotCount = slot.CurrentItem.settings_cookable.CookingSlotsRequired;
                            newTarget = targets;
                        }
                    }
                }
            }
        if (target)
        {
            if (dist > maxDist)
            {
                target = null;
                targetOffset = Vector3.zero;
                return;
            }
            targeted[this] = newTarget;
            if (cookItem)
            {
                box.GetInventoryReference().RemoveItemUses(cookItem.UniqueName, 1);
                box.Close();
                holding.Add(new ItemInstance(cookItem, 1, 1));
            }
            if (fuel != null && fuel.amount != 0)
            {
                box.GetInventoryReference().RemoveItem(fuel.item.UniqueName,fuel.amount);
                box.Close();
                holding.Add(fuel);
            }

        }
    }
    internal override bool tryInteract()
    {
        if (targetObject == null)
            return true;
        if (targetObject == box.transform)
            return tryDepositHeld();
        if (targetObject.IsRepelled() || box.transform.IsRepelled())
            return true;
        var target = targeted[this];
        foreach (var slot in target.Slots)
            if (!slot.IsComplete && slot.IsBusy && !(holding.Contains(target.stand.fuel.fuelItem) && !target.stand.fuel.HasMaxFuel()))
            {
                targeted[this] = CookingSlotTargets.Null;
                return true;
            }
        if (DistanceFromTarget > 0.2f)
            return false;
            if (holding.Contains(target.stand.fuel.fuelItem) && !target.stand.fuel.HasMaxFuel())
            {
                var m = Mathf.Min(target.stand.fuel.Missing(), holding.GetCount(target.stand.fuel.fuelItem));
                AddFuel(target.stand, m);
                holding.Remove(target.stand.fuel.fuelItem, m);
            }
            if (target.Slot.IsComplete)
            {
                holding.Add(target.Slot.CurrentItem.settings_cookable.CookingResult);
                ClearItem(target.stand, target.Slot);
            }
            else if (!target.Slot.IsBusy)
            {
                Item_Base item = null;
                foreach (var i in holding)
                {
                    bool all = true;
                    foreach (var s in target.Slots)
                        if (!s.CanCookItem(i.baseItem))
                        {
                            all = false;
                            break;
                        }
                    if (all)
                    {
                        item = i.baseItem;
                        break;
                    }
                }
                if (item != null)
                {
                    InsertItem(target, item);
                    holding.Remove(item, 1);
                }
            }
        targeted[this] = CookingSlotTargets.Null;
        return true;
    }

    static void ClearItem(CookingStand stand, CookingSlot slot)
    {
        var msg = new Message_Sprite_ClearCooker(stand, slot);
        msg.Use();
        msg.Message.Broadcast();
    }

    static void InsertItem(CookingSlotTargets slots, Item_Base item)
    {
        var msg = new Message_Sprite_InsertCooker(slots, item);
        msg.Use();
        msg.Message.Broadcast();
    }

    static void AddFuel(CookingStand stand, int amount)
    {
        var msg = new Message_Sprite_AddFuel(stand, amount);
        msg.Use();
        msg.Message.Broadcast();
    }

    static int InboundFuel(CookingStand stand)
    {
        var i = 0;
        foreach (var p in targeted)
            if (p.Value.stand == stand)
                i += p.Key.holding.GetCount(stand.fuel.fuelItem);
        return i;
    }

    public override void RestoreData(byte[] data) => targeted[this] = data.CookingSlotTargets(0);
    public override byte[] GenerateData() => targeted[this].Bytes();

    public override MonoBehaviour_ID FindTarget(uint objectIndex)
    {
        if (CookingStandManager.allCookingStands != null)
            foreach (var stand in CookingStandManager.allCookingStands)
                if (stand.ObjectIndex == objectIndex)
                    return stand;
        return base.FindTarget(objectIndex);
    }
}

class FireSprite2 : HelperSprite
{
    static Dictionary<FireSprite2, CookingTable> targeted = new Dictionary<FireSprite2, CookingTable>();
    SO_CookingTable_Recipe Recipe = null;
    public FireSprite2(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.5f, 0.625f), Random.Range(0, 0.125f), 0), objectIndex)
    {
        targeted.Add(this, null);
    }
    public override void Kill()
    {
        targeted.Remove(this);
        base.Kill();
    }

    internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
    {
        target = null;
        targetOffset = Vector3.zero;
        if (box.transform.IsRepelled())
            return;
        float dist = float.MaxValue;
        targeted[this] = null;
        Cost requiredItem = null;
        CookingTable_Recipe_UI recipe = null;
        Cost fuel = null;
        var fueling = true;
        var itemCount = new Dictionary<Item_Base, int>();
        var maxDist = box.GetInventoryReference().GetSlotCount() / 2f;
        if (!box.IsOpen)
            foreach (var table in BenevolentSprites.tables)
            {
                if (table == null || targeted.ContainsValue(table) || table.transform.IsRepelled())
                    continue;
                var newDist = Vector3.Distance(box.transform.position, table.transform.position);
                var collectionItem = Traverse.Create(table).Field("pickupFoodItem").GetValue<Item_Base>();
                CookingTable_Recipe_UI cooked = null;
                if (table.CurrentRecipe == null)
                    cooked = table.FindRecipe(box.GetInventoryReference().GetAllItems());
                itemCount.TryAdd(collectionItem, box.GetInventoryReference().GetItemCount(collectionItem));
                var f = 0;
                var fC = table.GetComponentInChildren<FuelNetwork>();
                if (fC)
                    f = Mathf.Max(Mathf.Min(fC.Fuel.Missing(), box.GetInventoryReference().GetItemCount(fC.Fuel.fuelItem)), 0);
                if ((newDist < dist || fueling) && newDist <= maxDist && (cooked || (table.Portions != 0 && itemCount[collectionItem] > 0) || (f != 0 && fueling)))
                {
                    fueling = f != 0;
                    if (fueling)
                        fuel = new Cost(fC.Fuel.fuelItem, f);
                    else
                        fuel = null;
                    recipe = null;
                    requiredItem = null;
                    if (table.CurrentRecipe == null)
                    {
                        recipe = cooked;
                        fueling = false;
                    }
                    else if (table.Portions != 0)
                    {
                        requiredItem = new Cost(collectionItem, Mathf.Min((int)table.Portions, itemCount[collectionItem]));
                        fueling = false;
                    }
                    target = table;
                    targetOffset = Vector3.up * 0.4f;
                    dist = newDist;
                    targeted[this] = table;
                }
            }
        Recipe = null;
        if (target)
        {
            if (dist > maxDist)
            {
                target = null;
                targetOffset = Vector3.zero;
                targeted[this] = null;
            }
            else
            {
                if (requiredItem != null)
                {
                    box.GetInventoryReference().RemoveItem(requiredItem.item.UniqueName, requiredItem.amount);
                    box.Close();
                    holding.Add(requiredItem);
                }
                else if (recipe)
                {
                    Recipe = recipe.Recipe;
                    holding.AddRange(box.GetInventoryReference().TakeItems(recipe.Recipe.RecipeCost));
                    box.Close();
                }
                if (fuel != null && fuel.amount != 0)
                {
                    box.GetInventoryReference().RemoveItem(fuel.item.UniqueName, fuel.amount);
                    box.Close();
                    holding.Add(fuel);
                }
            }
        }
    }
    internal override bool tryInteract()
    {
        if (targetObject == null)
            return true;
        if (targetObject == box.transform)
            return tryDepositHeld();
        if (targetObject.IsRepelled() || box.transform.IsRepelled())
            return true;
        var target = targeted[this];
        var f = targetObject.GetComponentInChildren<FuelNetwork>();
        if (!(f && holding.Contains(f.Fuel.fuelItem) && !f.Fuel.HasMaxFuel()) && (Recipe == null ? target.Portions == 0 : target.CurrentRecipe))
        {
            targeted[this] = null;
            return true;
        }
        if (DistanceFromTarget > 0.2f)
            return false;
        if (f && holding.Contains(f.Fuel.fuelItem) && !f.Fuel.HasMaxFuel())
        {
            var m = Mathf.Min(f.Fuel.Missing(), holding.GetCount(f.Fuel.fuelItem));
            AddFuel(target, m);
            holding.Remove(f.Fuel.fuelItem, m);
        }
        if (Recipe)
        {
            ForceStart(target, Recipe);
            holding.Remove(Recipe.RecipeCost);
        }
        else if (target.Portions != 0)
        {
            holding.Remove(Traverse.Create(target).Field("pickupFoodItem").GetValue<Item_Base>(), (int)target.Portions);
            holding.Add(new Cost(target.CurrentRecipe.Result, (int)target.Portions));
            ClearTable(target);
        }
        targeted[this] = null;
        return true;
    }

    static void AddFuel(CookingTable table, int amount)
    {
        var msg = new Message_Sprite_AddFuel(table, amount);
        msg.Use();
        msg.Message.Broadcast();
    }

    static void ForceStart(CookingTable table, SO_CookingTable_Recipe recipe)
    {
        var msg = new Message_Sprite_InsertTable(table, recipe);
        msg.Use();
        msg.Message.Broadcast();
    }

    static void ClearTable(CookingTable table)
    {
        var msg = new Message_Sprite_ClearTable(table);
        msg.Use();
        msg.Message.Broadcast();
    }

    public override void RestoreData(byte[] data)
    {
        targeted[this] = targetObject.GetComponent<CookingTable>();
        var ind = data.Integer(0);
        if (ind == -1)
            Recipe = null;
        else
            foreach (var r in Traverse.Create<CookingTable>().Field("allRecipes").GetValue<SO_CookingTable_Recipe[]>())
                if (r.RecipeIndex == ind)
                    Recipe = r;
    }

    public override byte[] GenerateData() => Recipe ? Recipe.RecipeIndex.Bytes() : (-1).Bytes();

    public override MonoBehaviour_ID FindTarget(uint objectIndex)
    {
        foreach (var table in BenevolentSprites.tables)
            if (table.ObjectIndex == objectIndex)
                return table;
        return base.FindTarget(objectIndex);
    }
}

class CleanerSprite : HelperSprite
{
    static Dictionary<CleanerSprite, MonoBehaviour_ID> targeted = new Dictionary<CleanerSprite, MonoBehaviour_ID>();
    public CleanerSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.875f, 1), Random.Range(0.875f, 1), 0), objectIndex)
    {
        targeted.Add(this, null);
    }
    public override void Kill()
    {
        targeted.Remove(this);
        base.Kill();
    }

    internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
    {
        target = null;
        targetOffset = Vector3.zero;
        if (box.transform.IsRepelled())
            return;
        float dist = float.MaxValue;
        targeted[this] = null;
        var maxDist = box.GetInventoryReference().GetSlotCount() / 2f;
        if (BenevolentSprites.seagulls != null)
            foreach (var seagull in BenevolentSprites.seagulls)
            {
                if (seagull == null || targeted.ContainsValue(seagull))
                    continue;
                var newDist = Vector3.Distance(box.transform.position, seagull.transform.position);
                if (newDist < dist && seagull.currentState == SeagullState.Peck)
                {
                    target = seagull;
                    targetOffset = Vector3.up * 0.2f;
                    dist = newDist;
                    targeted[this] = seagull;
                }
            }
        if (target == null || dist > maxDist)
            foreach (var net in BenevolentSprites.itemnets)
            {
                if (net == null || targeted.ContainsValue(net) || net.transform.IsRepelled())
                    continue;
                var newDist = Vector3.Distance(box.transform.position, net.transform.position);
                if (newDist < dist && net.GetComponentInChildren<ItemCollector>(true).collectedItems.Count != 0)
                {
                    target = net;
                    targetOffset = Vector3.up * 0.2f;
                    dist = newDist;
                    targeted[this] = net;
                }
            }
        if (target)
        {
            if (dist > maxDist)
            {
                target = null;
                targetOffset = Vector3.zero;
                targeted[this] = null;
            }
        }
    }
    internal override bool tryInteract()
    {
        if (targetObject == null)
            return true;
        if (targetObject == box.transform)
            return tryDepositHeld();
        if (targetObject.IsRepelled() || box.transform.IsRepelled())
            return true;
        var seagull = targetObject.GetComponent<Seagull>();
        var net = targetObject.GetComponentInChildren<ItemCollector>(true);
        if ((net && net.collectedItems.Count == 0) || (seagull && seagull.currentState != SeagullState.Peck))
        {
            targeted[this] = null;
            return true;
        }
        if (DistanceFromTarget > 0.5f)
            return false;
        if (seagull)
        {
            seagull.entityComponent.Damage(5f, seagull.transform.position, Vector3.down, EntityType.Enemy);
            if (seagull.entityComponent.IsDead)
            {
                holding.AddRange(seagull.pickupItemChanneling.pickupItem.GetAllItems());
                seagull.pickupItem.networkID.Remove();
            }
        }
        else if (net)
        {
            foreach (var pickup in net.collectedItems)
            {
                var newItems = pickup.PickupItem.GetAllItems();
                foreach (var item in newItems)
                    if (item.settings_recipe.IsBlueprint)
                        ComponentManager<Inventory_ResearchTable>.Value.ResearchBlueprint(item.baseItem);
                holding.AddRange(newItems);
            }
            
            ClearAll(net);
        }
        targeted[this] = null;
        return true;
    }

    static void ClearAll(ItemCollector collector)
    {
        var msg = new Message_Sprite_ClearAll(collector);
        msg.Use();
        msg.Message.Broadcast();
    }

    public override void RestoreData(byte[] data)
    {
        targeted[this] = targetObject.GetComponent<MonoBehaviour_ID>();
    }

    public override MonoBehaviour_ID FindTarget(uint objectIndex)
    {
        if (BenevolentSprites.seagulls != null)
            foreach (var seagull in BenevolentSprites.seagulls)
                if (seagull.ObjectIndex == objectIndex)
                    return seagull;
        foreach (var net in BenevolentSprites.itemnets)
            if (net.ObjectIndex == objectIndex)
                return net;
        return base.FindTarget(objectIndex);
    }
}

class ModLoadException : System.Exception
{
    public ModLoadException(string message) : base(message) { }
}

[HarmonyPatch(typeof(HMLLibrary.ModManagerPage), "ShowModInfo")]
class Patch_ShowModInfo
{
    static void Postfix(ModData md)
    {
        if (md.modinfo.mainClass && md.modinfo.mainClass.GetType() == typeof(BenevolentSprites))
            HMLLibrary.ModManagerPage.modInfoObj.transform.Find("MakePermanent").gameObject.SetActive(true);
    }
}

[HarmonyPatch(typeof(Storage_Small), "Close")]
class Patch_CloseStorage
{
    static void Postfix(Storage_Small __instance)
    {
        if (BenevolentSprites.gameLoaded && Semih_Network.IsHost)
        {
            foreach (var slot in __instance.GetInventoryReference().allSlots)
                if (slot.HasSprite() && slot.GetSprite() == null)
                {
                    if (slot.itemInstance.TryGetData(out var data) && data.ContainsKey(BenevolentSprites.dataKey))
                        BenevolentSprites.CreateSprite(data[BenevolentSprites.dataKey]);
                    else
                        BenevolentSprites.CreateSprite(__instance, slot);
                }
        }
    }
}

[HarmonyPatch(typeof(GameManager), "OnWorldRecievedLate")]
class Patch_RemoteWorldLoaded
{
    static void Postfix(Storage_Small __instance)
    {
        BenevolentSprites.gameLoaded = true;
        int i = -1;
        string str = "";
        foreach (var message in BenevolentSprites.waiting)
            try
            {
                i++;
                BenevolentSprites.ProcessMessage(message);
            }
            catch (System.Exception e)
            {
                str += "\n" + i + "/" + BenevolentSprites.waiting.Count + " | Message type: " + MessageType.getName(message.appBuildID) + " | Top Stacktrace : " + e.StackTrace.Split('\n')[0];
            }
        if (str.Length != 0)
            Debug.LogWarning("Some qued messages failed:" + str);
        BenevolentSprites.waiting.Clear();
    }
}

[HarmonyPatch(typeof(RGD_Slot), MethodType.Constructor, new System.Type[] { typeof(Slot), typeof(int) })]
class Patch_SaveSlot
{
    static void Prefix(ref bool __state, Slot slot)
    {
        if (slot == null || !slot.HasValidItemInstance() || BenevolentSprites.spriteClosingBox)
            return;
        var sprite = slot.GetSprite();
        __state = sprite != null && !sprite.dying;
        if (__state)
            slot.itemInstance.SetValue(BenevolentSprites.dataKey, new Message_Sprite_Recreate(sprite).Message.password + sprite.holding.Bytes().String() + sprite.GenerateData().String());
        //Debug.Log("Sprite data: " + slot.itemInstance.exclusiveString.Length);
    }
    static void Postfix(bool __state, Slot slot)
    {
        if (__state)
            slot.itemInstance.RemoveValue(BenevolentSprites.dataKey);
    }
}

[HarmonyPatch(typeof(Slot), "SetItem", new System.Type[] { typeof(ItemInstance) })]
class Patch_ChangeSlot
{
    static void Postfix(Slot __instance)
    {
        if (__instance.HasSprite() && BenevolentSprites.gameLoaded)
        {
            if (__instance.itemInstance.TryGetData(out var data))
                __instance.itemInstance.RemoveValue(BenevolentSprites.dataKey);
            else
                __instance.itemInstance.exclusiveString = "";
        }
    }
}

[HarmonyPatch(typeof(SoundManager), "PlayUI_MoveItem")]
class Patch_PlayMoveItemSound
{
    static bool Prefix()
    {
        return !System.Environment.StackTrace.Contains("HelperSprite.tryDepositHeld");
    }
}

[HarmonyPatch(typeof(AI_NetworkBehaviour_Domestic_Resource))]
class Patch_Domestic_Resource
{
    [HarmonyPatch("Start")]
    [HarmonyPostfix]
    static void Start(AI_NetworkBehaviour_Domestic_Resource __instance) => BenevolentSprites.animals.Add(__instance);


    [HarmonyPatch("OnDestroy")]
    [HarmonyPostfix]
    static void OnDestroy(AI_NetworkBehaviour_Domestic_Resource __instance) => BenevolentSprites.animals.Remove(__instance);
}

[HarmonyPatch(typeof(NetworkIDManager), new System.Type[] { typeof(MonoBehaviour_ID_Network), typeof(System.Type), typeof(NetworkIDTag) })]
class Patch_NetworkedObject
{
    [HarmonyPatch("AddNetworkID")]
    [HarmonyPostfix]
    static void Add(MonoBehaviour_ID_Network networkID, NetworkIDTag tag)
    {
        if (networkID is Seagull)
            BenevolentSprites.seagulls.Add((Seagull)networkID);
        if (tag == NetworkIDTag.ChickenEgg && networkID is PickupItem_Networked)
            BenevolentSprites.eggs.Add((PickupItem_Networked)networkID);
    }


    [HarmonyPatch("RemoveNetworkID")]
    [HarmonyPostfix]
    static void Remove(MonoBehaviour_ID_Network networkID, NetworkIDTag tag)
    {
        if (networkID is Seagull)
            BenevolentSprites.seagulls.Remove((Seagull)networkID);
        if (tag == NetworkIDTag.ChickenEgg && networkID is PickupItem_Networked)
            BenevolentSprites.eggs.Remove((PickupItem_Networked)networkID);
    }
}

[HarmonyPatch(typeof(Block), "OnFinishedPlacement")]
class Patch_Block
{
    static void Postfix(Block __instance)
    {
        if (__instance is Block_Foundation_ItemNet)
            BenevolentSprites.itemnets.Add((Block_Foundation_ItemNet)__instance);
        if (__instance.GetComponent<BeeHive>())
            BenevolentSprites.beehives.Add(__instance.GetComponent<BeeHive>());
        if (__instance.GetComponent<CookingTable_Recipe_UI>())
            BenevolentSprites.recipes.Add(__instance.GetComponent<CookingTable_Recipe_UI>());
        if (__instance.GetComponent<CookingTable>())
            BenevolentSprites.tables.Add(__instance.GetComponent<CookingTable>());
    }
}

[HarmonyPatch]
class Patch_InventoryOverrides
{
    public static GameObject ignore = null;
    [HarmonyPatch(typeof(Hotbar), "ReselectCurrentSlot")]
    [HarmonyPrefix]
    static bool reselect(Hotbar __instance) => __instance.gameObject != ignore;
    [HarmonyPatch(typeof(InventoryPickup), "ShowItem")]
    [HarmonyPrefix]
    static bool show(InventoryPickup __instance) => __instance.gameObject != ignore;
    [HarmonyPatch(typeof(PlayerInventory), "HandleNewItemAdded")]
    [HarmonyPrefix]
    static bool handle(PlayerInventory __instance) => __instance.gameObject != ignore;
}

struct CookingSlotTargets
{
    public static CookingSlotTargets Null = new CookingSlotTargets(null, -1, 0);
    public int slotInd;
    public int slotCount;
    public CookingStand stand;
    public uint ObjectIndex
    {
        get => stand == null ? 0 : stand.ObjectIndex;
        set
        {
            foreach (var s in CookingStandManager.allCookingStands)
                if (s.ObjectIndex == value)
                {
                    stand = s;
                    return;
                }
        }
    }
    public CookingSlot Slot
    {
        get => stand ? stand.cookingSlots[slotInd] : null;
        set
        {
            if (value == null)
            {
                stand = null;
                slotInd = -1;
                slotCount = 0;
                return;
            }
            if (stand)
                slotInd = stand.GetIndexOfCookingSlot(value);
            if (slotInd == -1)
            {
                var nStand = value.GetComponentInParent<CookingStand>();
                if (nStand && nStand != stand)
                {
                    slotInd = nStand.GetIndexOfCookingSlot(value);
                    stand = nStand;
                }
            }
            if (slotInd == -1)
                throw new System.NullReferenceException();
            slotCount = 1;
        }
    }
    public List<CookingSlot> Slots
    {
        get
        {
            var slots = new List<CookingSlot>();
            if (stand)
                for (int i = 0; i < slotCount; i++)
                    slots.Add(stand.cookingSlots[slotInd + i]);
            return slots;
        }
        set
        {
            if (value == null || value.Count == 0)
            {
                stand = null;
                slotInd = -1;
                slotCount = 0;
                return;
            }
            if (stand)
                slotInd = stand.GetIndexOfCookingSlot(value[0]);
            if (slotInd == -1)
            {
                var nStand = value[0].GetComponentInParent<CookingStand>();
                if (nStand && nStand != stand)
                {
                    slotInd = nStand.GetIndexOfCookingSlot(value[0]);
                    stand = nStand;
                }
            }
            slotCount = 0;
            if (slotInd == -1)
                throw new System.NullReferenceException();
            slotCount = value.Count;
        }
    }
    public CookingSlotTargets(CookingStand Stand, int SlotIndex, int SlotCount)
    {
        stand = Stand;
        slotInd = SlotIndex;
        slotCount = SlotCount;
    }
    public CookingSlotTargets(uint objectIndex, int SlotIndex, int SlotCount = 1) : this(null, SlotIndex, SlotCount)
    {
        ObjectIndex = objectIndex;
    }
    public CookingSlotTargets(CookingSlot slot) : this(null, -1, 0)
    {
        Slot = slot;
    }
    public CookingSlotTargets(List<CookingSlot> slots) : this(null, -1, 0)
    {
        Slots = slots;
    }

    public override bool Equals(object obj)
    {
        if (obj is CookingSlotTargets)
            return Equals((CookingSlotTargets)obj);
        return base.Equals(obj);
    }

    public bool Equals(CookingSlotTargets target)
    {
        return target.ObjectIndex == ObjectIndex && RangesOverlap(slotInd, slotInd + slotCount, target.slotInd, target.slotInd + target.slotCount);
    }

    static bool RangesOverlap(int a1, int a2, int b1, int b2)
    {
        return (a1 >= b1 && a1 <= b2) || (a2 >= b1 && a2 <= b2) || (b1 >= a1 && b1 <= a2) || (b2 >= a1 && b2 <= a2);
    }

    public static implicit operator CookingSlotTargets(CookingSlot slot) => new CookingSlotTargets(slot);
    public static implicit operator CookingSlotTargets(List<CookingSlot> slots) => new CookingSlotTargets(slots);
}

public struct MessageType
{
    public const int ChannelID = 8;
    public const Messages MessageID = (Messages)23468;
    public const int Create = 0;
    public const int Target = 1;
    public const int Kill = 2;
    public const int Recreate = 3;
    public const int PlantSeed = 4;
    public const int ClearCooker = 5;
    public const int InsertCooker = 6;
    public const int AddFuel = 7;
    public const int InsertTable = 8;
    public const int ClearTable = 9;
    public const int ClearAll = 10;
    public static Dictionary<int, System.Reflection.ConstructorInfo> Contructor = new Dictionary<int, System.Reflection.ConstructorInfo>
    {
        [Create] = typeof(Message_Sprite_Create).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [Target] = typeof(Message_Sprite_SetTarget).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [Kill] = typeof(Message_Sprite_Kill).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [Recreate] = typeof(Message_Sprite_Recreate).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [PlantSeed] = typeof(Message_Sprite_PlantSeed).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [ClearCooker] = typeof(Message_Sprite_ClearCooker).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [InsertCooker] = typeof(Message_Sprite_InsertCooker).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [AddFuel] = typeof(Message_Sprite_AddFuel).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [InsertTable] = typeof(Message_Sprite_InsertTable).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [ClearTable] = typeof(Message_Sprite_ClearTable).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) }),
        [ClearAll] = typeof(Message_Sprite_ClearAll).GetConstructor(new System.Type[] { typeof(Message_InitiateConnection) })
    };

    public static string getName(int msgId)
    {
        switch (msgId)
        {
            case 0:
                return "Create Sprite";
            case 1:
                return "Set Sprite Target";
            case 2:
                return "Kill Sprite";
            case 3:
                return "Create Sprite from Serial";
            case 4:
                return "Plant Seed";
            case 5:
                return "Empty Cooking Stand Slots";
            case 6:
                return "Set Cooking Stand Slots";
            case 7:
                return "Add Fuel";
            case 8:
                return "Insert Cooking Table Recipe";
            case 9:
                return "Empty Cooking Table";
            case 10:
                return "Empty Item Net";
        }
        return "Unknown (" + msgId + ")";
    }
}

abstract class Message_Sprite
{
    public abstract void Use();
}

class Message_Sprite_Create : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(spriteIndex.Bytes());
            data.AddRange(boxIndex.Bytes());
            data.AddRange(slotIndex.Bytes());
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.Create, data.String());
        }
    }
    public Storage_Small Box
    {
        get
        {
            foreach (var box in StorageManager.allStorages)
                if (box.ObjectIndex == boxIndex)
                    return box;
            return null;
        }
    }
    public Slot Slot
    {
        get
        {
            var box = Box;
            if (box == null || box.GetInventoryReference().allSlots.Count <= slotIndex || slotIndex < 0)
                return null;
            return box.GetInventoryReference().allSlots[slotIndex];
        }
    }
    public HelperSprite Sprite
    {
        get
        {
            foreach (var sprite in BenevolentSprites.sprites)
                if (sprite.ObjectIndex == spriteIndex)
                    return sprite;
            return null;
        }
    }
    public uint SpriteIndex { get { return spriteIndex; } }
    uint spriteIndex;
    uint boxIndex;
    int slotIndex;
    public Message_Sprite_Create(HelperSprite sprite)
    {
        spriteIndex = sprite.ObjectIndex;
        boxIndex = sprite.box.ObjectIndex;
        slotIndex = sprite.box.GetInventoryReference().allSlots.IndexOf(sprite.store);
    }
    public Message_Sprite_Create(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        spriteIndex = data.UInteger(0);
        boxIndex = data.UInteger(4);
        slotIndex = data.Integer(8);
    }

    public override void Use() => BenevolentSprites.CreateSprite(Box, Slot, SpriteIndex);
}

class Message_Sprite_SetTarget : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(spriteIndex.Bytes());
            data.AddRange(targetIndex.Bytes());
            data.AddRange(targetOffset.Bytes());
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.Target, data.String());
        }
    }
    public Vector3 Offset { get { return targetOffset; } }
    public MonoBehaviour_ID Target
    {
        get
        {
            return Sprite.FindTarget(targetIndex);
        }
    }
    public HelperSprite Sprite
    {
        get
        {
            foreach (var sprite in BenevolentSprites.sprites)
                if (sprite.ObjectIndex == spriteIndex)
                    return sprite;
            return null;
        }
    }
    uint spriteIndex;
    uint targetIndex;
    Vector3 targetOffset;
    public Message_Sprite_SetTarget(HelperSprite sprite,MonoBehaviour_ID Target,Vector3 TargetOffset)
    {
        spriteIndex = sprite.ObjectIndex;
        targetIndex = Target.ObjectIndex;
        targetOffset = TargetOffset;
    }
    public Message_Sprite_SetTarget(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        spriteIndex = data.UInteger(0);
        targetIndex = data.UInteger(4);
        targetOffset = data.Vector3(8);
    }

    public override void Use() => Sprite.SetTargetNetwork(Target, Offset);
}

class Message_Sprite_Kill : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.Kill, spriteIndex.Bytes().String());
        }
    }
    public HelperSprite Sprite
    {
        get
        {
            foreach (var sprite in BenevolentSprites.sprites)
                if (sprite.ObjectIndex == spriteIndex)
                    return sprite;
            return null;
        }
    }
    uint spriteIndex;
    public Message_Sprite_Kill(HelperSprite sprite)
    {
        spriteIndex = sprite.ObjectIndex;
    }
    public Message_Sprite_Kill(Message_InitiateConnection message)
    {
        spriteIndex = message.password.Bytes().UInteger(0);
    }

    public override void Use() => Sprite.Kill();
}

class Message_Sprite_Recreate : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(spriteIndex.Bytes());
            data.AddRange(boxIndex.Bytes());
            data.AddRange(slotIndex.Bytes());
            data.AddRange(targetIndex.Bytes());
            data.AddRange(targetOffset.Bytes());
            data.AddRange(position.Bytes());
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.Recreate, data.String());
        }
    }
    public Storage_Small Box
    {
        get
        {
            foreach (var box in StorageManager.allStorages)
                if (box.ObjectIndex == boxIndex)
                    return box;
            Debug.LogWarning("Failed to find storage with id " + boxIndex);
            return null;
        }
    }
    public Slot Slot
    {
        get
        {
            var box = Box;
            if (box == null || box.GetInventoryReference().allSlots.Count <= slotIndex || slotIndex < 0)
                return null;
            return box.GetInventoryReference().allSlots[slotIndex];
        }
    }
    public HelperSprite Sprite
    {
        get
        {
            foreach (var sprite in BenevolentSprites.sprites)
                if (sprite.ObjectIndex == spriteIndex)
                    return sprite;
            return null;
        }
    }
    public Vector3 Offset { get { return targetOffset; } }
    public Vector3 Position { get { return position; } }
    public uint TargetIndex { get { return targetIndex; } }
    public uint SpriteIndex { get { return spriteIndex; } }
    uint spriteIndex;
    uint boxIndex;
    int slotIndex;
    uint targetIndex;
    Vector3 targetOffset;
    Vector3 position;
    public Message_Sprite_Recreate(HelperSprite sprite)
    {
        spriteIndex = sprite.ObjectIndex;
        boxIndex = sprite.box.ObjectIndex;
        slotIndex = sprite.box.GetInventoryReference().allSlots.IndexOf(sprite.store);
        targetIndex = sprite.targetObject.GetComponent<MonoBehaviour_ID>().ObjectIndex;
        targetOffset = sprite.targetPosition;
        position = sprite.gameObject.transform.localPosition;
    }
    public Message_Sprite_Recreate(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        spriteIndex = data.UInteger(0);
        boxIndex = data.UInteger(4);
        slotIndex = data.Integer(8);
        targetIndex = data.UInteger(12);
        targetOffset = data.Vector3(16);
        position = data.Vector3(28);
    }

    public override void Use()
    {
        var sprite = BenevolentSprites.CreateSprite(Box, Slot, SpriteIndex);
        sprite.gameObject.transform.localPosition = Position;
        sprite.SetTarget(sprite.FindTarget(TargetIndex).transform, Offset);
    }
}

class Message_Sprite_PlantSeed : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(cropIndex.Bytes());
            data.AddRange(itemIndex.Bytes());
            data.AddRange(objectIndex.Bytes());
            data.Add((byte)(water ? 1 : 0));
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.PlantSeed, data.String());
        }
    }
    public Cropplot Plot
    {
        get
        {
            foreach (var plot in PlantManager.allCropplots)
                if (plot.ObjectIndex == cropIndex)
                    return plot;
            return null;
        }
    }
    public int ItemIndex { get => itemIndex; }
    public uint ObjectIndex { get => objectIndex; }
    public bool WaterCrop { get => water; }
    uint cropIndex;
    int itemIndex;
    uint objectIndex;
    bool water;
    public Message_Sprite_PlantSeed(Cropplot Plot, int ItemIndex, uint ObjectIndex, bool WaterCrop)
    {
        cropIndex = Plot.ObjectIndex;
        itemIndex = ItemIndex;
        objectIndex = ObjectIndex;
        water = WaterCrop;
    }
    public Message_Sprite_PlantSeed(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        cropIndex = data.UInteger(0);
        itemIndex = data.Integer(4);
        objectIndex = data.UInteger(8);
        water = data[12] == 1;
    }

    public override void Use()
    {
        var crop = Plot;
        crop.plantManager.PlantSeed(crop, crop.plantManager.GetPlantByIndex(ItemIndex), ObjectIndex, WaterCrop, false);
    }
}

class Message_Sprite_ClearCooker : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(standIndex.Bytes());
            data.AddRange(slotIndex.Bytes());
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.ClearCooker, data.String());
        }
    }
    public CookingStand Stand
    {
        get
        {
            foreach (var stand in CookingStandManager.allCookingStands)
                if (stand.ObjectIndex == standIndex)
                    return stand;
            return null;
        }
    }
    public int Slot => slotIndex;
    uint standIndex;
    int slotIndex;
    public Message_Sprite_ClearCooker(CookingStand Stand, CookingSlot Slot)
    {
        standIndex = Stand.ObjectIndex;
        slotIndex = Stand.GetIndexOfCookingSlot(Slot);
    }
    public Message_Sprite_ClearCooker(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        standIndex = data.UInteger(0);
        slotIndex = data.Integer(4);
    }

    public override void Use()
    {
        var stand = Stand;
        stand.CollectItem(stand.cookingSlots[Slot], false);
    }
}

class Message_Sprite_InsertCooker : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(slots.Bytes());
            data.AddRange(itemIndex.Bytes());
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.InsertCooker, data.String());
        }
    }
    public CookingSlotTargets Slots => slots;
    public Item_Base Item => ItemManager.GetItemByIndex(itemIndex);
    CookingSlotTargets slots;
    int itemIndex;
    public Message_Sprite_InsertCooker(CookingSlotTargets Slots, Item_Base Item)
    {
        slots = Slots;
        itemIndex = Item.UniqueIndex;
    }
    public Message_Sprite_InsertCooker(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        slots = data.CookingSlotTargets(0);
        itemIndex = data.Integer(12);
    }

    public override void Use() => Slots.stand.InsertItem(Item, Slots.Slots.ToArray(), false);
}

class Message_Sprite_AddFuel : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(objectIndex.Bytes());
            data.AddRange(amount.Bytes());
            data.AddRange(type.Bytes());
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.AddFuel, data.String());
        }
    }
    public Fuel Fuel
    {
        get
        {
            if (type == 1)
                foreach (var stand in CookingStandManager.allCookingStands)
                    if (stand.ObjectIndex == objectIndex)
                        return stand.fuel;
            if (type == 2)
                return NetworkIDManager.GetNetworkIDFromObjectIndex<CookingTable>(objectIndex).GetComponentInChildren<FuelNetwork>().Fuel;
            return null;
        }
    }
    public int Amount => amount;
    uint objectIndex;
    int type;
    int amount;
    public Message_Sprite_AddFuel(CookingStand Stand, int Amount)
    {
        objectIndex = Stand.ObjectIndex;
        amount = Amount;
        type = 1;
    }
    public Message_Sprite_AddFuel(CookingTable Table, int Amount)
    {
        objectIndex = Table.ObjectIndex;
        amount = Amount;
        type = 2;
    }
    public Message_Sprite_AddFuel(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        objectIndex = data.UInteger(0);
        amount = data.Integer(4);
        type = data.Integer(8);
    }

    public override void Use() => Fuel.AddFuel(Amount);
}

class Message_Sprite_InsertTable : Message_Sprite
{
    public Message_InitiateConnection Message
    {
        get
        {
            var data = new List<byte>();
            data.AddRange(tableIndex.Bytes());
            data.AddRange(recipeIndex.Bytes());
            return new Message_InitiateConnection(MessageType.MessageID, MessageType.InsertTable, data.String());
        }
    }
    public CookingTable Table => NetworkIDManager.GetNetworkIDFromObjectIndex<CookingTable>(tableIndex);
    public SO_CookingTable_Recipe Recipe
    {
        get
        {
            foreach (var recipe in Traverse.Create<CookingTable>().Field("allRecipes").GetValue<SO_CookingTable_Recipe[]>())
                if (recipe.RecipeIndex == recipeIndex)
                    return recipe;
            return null;
        }
    }
    uint tableIndex;
    uint recipeIndex;
    public Message_Sprite_InsertTable(CookingTable Table, SO_CookingTable_Recipe Recipe)
    {
        tableIndex = Table.ObjectIndex;
        recipeIndex = Recipe.RecipeIndex;
    }
    public Message_Sprite_InsertTable(Message_InitiateConnection message)
    {
        var data = message.password.Bytes();
        tableIndex = data.UInteger(0);
        recipeIndex = data.UInteger(4);
    }

    public override void Use() => Table.ForceStart(Recipe);
}

class Message_Sprite_ClearTable : Message_Sprite
{
    public Message_InitiateConnection Message => new Message_InitiateConnection(MessageType.MessageID, MessageType.ClearTable, tableIndex.Bytes().String());
    public CookingTable Table => NetworkIDManager.GetNetworkIDFromObjectIndex<CookingTable>(tableIndex);
    uint tableIndex;
    public Message_Sprite_ClearTable(CookingTable Table) => tableIndex = Table.ObjectIndex;
    public Message_Sprite_ClearTable(Message_InitiateConnection message) => tableIndex = message.password.Bytes().UInteger(0);

    public override void Use() => Table.Clear();
}

class Message_Sprite_ClearAll : Message_Sprite
{
    public Message_InitiateConnection Message => new Message_InitiateConnection(MessageType.MessageID, MessageType.ClearAll, collectorIndex.Bytes().String());
    public ItemCollector Collector
    {
        get
        {
            foreach (var collector in GameObject.FindObjectsOfType<ItemCollector>())
                if (collector.ObjectIndex == collectorIndex)
                    return collector;
            return null;
        }
    }
    uint collectorIndex;
    public Message_Sprite_ClearAll(ItemCollector Collector) => collectorIndex = Collector.ObjectIndex;
    public Message_Sprite_ClearAll(Message_InitiateConnection message) => collectorIndex = message.password.Bytes().UInteger(0);

    public override void Use() => Traverse.Create(Collector).Method("ClearCollectedItems", new System.Type[] { typeof(Network_Player) }, new object[] { null }).GetValue();
}